---
title: <defs>
slug: Web/SVG/Element/defs
tags:
  - SVG
  - SVG Container
---
<div>{{SVGRef}}</div>

<p>The <strong><code>&lt;defs&gt;</code></strong> element is used to store graphical objects that will be used at a later time. Objects created inside a <code>&lt;defs&gt;</code> element are not rendered directly. To display them you have to reference them (with a {{SVGElement("use")}} element for example).</p>

<p>Graphical objects can be referenced from anywhere, however, defining these objects inside of a <code>&lt;defs&gt;</code> element promotes understandability of the SVG content and is beneficial to the overall accessibility of the document.</p>

<div id="Exemple">
<div class="hidden">
<pre class="brush: css">html,body,svg { height:100% }</pre>
</div>

<pre class="brush: html">&lt;svg viewBox="0 0 10 10" xmlns="http://www.w3.org/2000/svg"
     xmlns:xlink="http://www.w3.org/1999/xlink"&gt;
  &lt;!-- Some graphical objects to use --&gt;
  &lt;defs&gt;
    &lt;circle id="myCircle" cx="0" cy="0" r="5" /&gt;

    &lt;linearGradient id="myGradient" gradientTransform="rotate(90)"&gt;
      &lt;stop offset="20%" stop-color="gold" /&gt;
      &lt;stop offset="90%" stop-color="red" /&gt;
    &lt;/linearGradient&gt;
  &lt;/defs&gt;

  &lt;!-- using my graphical objects --&gt;
  &lt;use x="5" y="5" xlink:href="#myCircle" fill="url('#myGradient')" /&gt;
&lt;/svg&gt;</pre>

<p>{{EmbedLiveSample('Exemple', 150, '100%')}}</p>
</div>

<h2 id="Attributes">Attributes</h2>

<h3 id="Global_attributes">Global attributes</h3>

<dl>
 <dt><a href="/docs/Web/SVG/Attribute/Core">Core Attributes</a></dt>
 <dd><small>Most notably: {{SVGAttr('id')}} {{SVGAttr('lang')}}</small></dd>
 <dt><a href="/docs/Web/SVG/Attribute/Styling">Styling Attributes</a></dt>
 <dd><small>{{SVGAttr('class')}}, {{SVGAttr('style')}}</small></dd>
 <dt>Event Attributes</dt>
 <dd><small><a href="/docs/Web/SVG/Attribute/Events#Global_Event_Attributes">Global event attributes</a>, <a href="/docs/Web/SVG/Attribute/Events#Document_Element_Event_Attributes">Document element event attributes</a>, <a href="/docs/Web/SVG/Attribute/Events#Graphical_Event_Attributes">Graphical event attributes</a></small></dd>
 <dt><a href="/docs/Web/SVG/Attribute/Presentation">Presentation Attributes</a></dt>
 <dd><small>Most notably: {{SVGAttr('clip-path')}}, {{SVGAttr('clip-rule')}}, {{SVGAttr('color')}}, {{SVGAttr('color-interpolation')}}, {{SVGAttr('color-rendering')}}, {{SVGAttr('cursor')}}, {{SVGAttr('display')}}, {{SVGAttr('fill')}}, {{SVGAttr('fill-opacity')}}, {{SVGAttr('fill-rule')}}, {{SVGAttr('filter')}}, {{SVGAttr('mask')}}, {{SVGAttr('opacity')}}, {{SVGAttr('pointer-events')}}, {{SVGAttr('shape-rendering')}}, {{SVGAttr('stroke')}}, {{SVGAttr('stroke-dasharray')}}, {{SVGAttr('stroke-dashoffset')}}, {{SVGAttr('stroke-linecap')}}, {{SVGAttr('stroke-linejoin')}}, {{SVGAttr('stroke-miterlimit')}}, {{SVGAttr('stroke-opacity')}}, {{SVGAttr('stroke-width')}}, {{SVGAttr("transform")}}, {{SVGAttr('vector-effect')}}, {{SVGAttr('visibility')}}</small></dd>
</dl>

<h2 id="Usage_notes">Usage notes</h2>

<p>{{svginfo}}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName("SVG2", "struct.html#Head", "&lt;defs&gt;")}}</td>
   <td>{{Spec2("SVG2")}}</td>
   <td>No change</td>
  </tr>
  <tr>
   <td>{{SpecName("SVG1.1", "struct.html#Head", "&lt;defs&gt;")}}</td>
   <td>{{Spec2("SVG1.1")}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("svg.elements.defs")}}</p>
